//  Persistance of Vision Raytracer V2.2
//  World definition file.
//
//  Contains 2 lights, 4 textures and 4 primitives.
//
//  This file was generated for POV-Ray V2.2 by
//  MORAY.EXE V2.0.wat(c) 1991-1995 Lutz + Kretzschmar
//

//  Date : 11/26/1996    (26.11.1996)
//

#max_trace_level 5

#declare camera_start = <-4.45,1.9,-1.2>
#declare camera_end   = <2.15,3.05,3.95>

#declare lookat = <1.150, 11.950, 7.600>
#declare time = clock
#declare cam_loc = camera_start + (camera_end - camera_start)*time
camera {  //  Camera StdCam
  location  cam_loc
  direction <0.0,     0.0,  1.0491>
  sky       <0.0,     0.0,  1.0>  // Use right handed-system!
  up        <0.0,     0.0,  1.0>  // Where Z is up
  right     <1.3333,  0.0,  0.0>
  look_at   lookat
}

#include "lens_a.inc"

light_source {   // Light001
  <-53.100, 60.850, 59.000>
  color rgb <1.000, 1.000, 1.000>
}

#declare light_loc = <-3977.750059, 65195.650971, 41716.850622>
#declare light_rad = 1500
sphere { // Sun
  <0,0,0>,1
  texture { White }
  no_shadow
  scale light_rad
  translate  light_loc
}
light_source {   // Light1
  light_loc
  color rgb <1.000, 1.000, 1.000>
}

#declare planet_loc = <9.12, 22.95, 13.15>
#declare planet_rad = 9.55
sphere { // Planet
  <0,0,0>, 1
  texture {  Planet_surface }
  scale planet_rad
  translate planet_loc
}
sphere {
  <0,0,0>, 1
  texture { Planet_clouds
       translate .01*time
       rotate 90*y
       rotate 10*time*z
       //10 degrees of rotation
  }
  scale planet_rad*1.01
  translate planet_loc
}

//#declare flare_shrink = true
#declare flare_type = "105mm"
#include "lnsflare.inc"

